/*
* wstart - start executable with delay before starting.
*/

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{
	struct stat st;

	if (argc < 3)
	{
		fprintf(stderr, "Usage: %s <waiting path> <command> [args]\n", argv[0]);
		exit(-1);
	}

	printf("Starting initialization command...");
	fflush(stdout);
	
	while(stat(argv[1], &st))
	{
		printf("..");
		fflush(stdout);
		sleep(1);
	}
	printf("\n");
	fflush(stdout);

	if (execv(argv[2], &argv[2]) < 0)
	{
		perror("execv() error!");
		exit(-1);
	}

	return (0);
}
