#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>

#include <sys/stat.h>
#include <sys/qnx_glob.h>

//#define __DEBUG

#define SPWN_F (_SPAWN_NOZOMBIE | _SPAWN_NOHUP | \
				/*_SPAWN_BGROUND | */_SPAWN_SETSID | \
				_SPAWN_NEWPGRP | _SPAWN_TCSETPGRP)

int main(int argc, char **argv, char **arge)
{
	struct stat st;
	char mount_point[_MAX_PATH];
	char decompressor[_MAX_PATH], rdfile[_MAX_PATH], *sinit;
	int i;
	pid_t pid;

	if (argc < 5)
	{
		fprintf(stderr, "Artiom N. bootdisk startup program.\n");
		fprintf(stderr, "Syntax: %1 <mount point> <ramdisk file> <decompressor> <initial program [parameters]>\n", argv[0]);
		return(-1);
	}

	#ifdef __DEBUG
	printf("args: %s %s %s %s %s\n", argv[1], argv[2], argv[3], argv[4], argv[5]);
	#endif

	//qnx_spawn_options.flags = SPWN_F;

	strncpy(mount_point, argv[1], _MAX_PATH);
	strncat(mount_point, "/", _MAX_PATH);
	strncpy(rdfile, mount_point, _MAX_PATH);
	strncat(rdfile, argv[2], _MAX_PATH);
	strncpy(decompressor, mount_point, _MAX_PATH);
	strncat(decompressor, argv[3], _MAX_PATH);
	sinit = argv[4];
	#ifdef __DEBUG
	printf("mount_point: %s, rdfile: %s, decompressor: %s, sinit: %s\n",
		mount_point, rdfile, decompressor, sinit, argv[5]);
	#endif
	
	setsid();
	setgid(0);

	printf("Waiting for %s...", argv[1]);
	fflush(stdout);
	while(stat(argv[1], &st))
	{
		printf("..");
		fflush(stdout);
		sleep(1);
	}

	printf("\n");

	if ((i = open("/dev/ram", O_RDWR)) == -1)
	{
		fprintf(stderr, "Error: can't open /dev/ram (code: %d)!\n", errno);
		return(1);
	}

	qnx_spawn_options.iov[1] = i;

	printf("Executing decompressor (%s %s)...\n", decompressor, rdfile);
	fflush(stdout);
	if ((pid = spawnl(P_WAIT, decompressor, basename(decompressor), rdfile, NULL)) == -1)
	{
		fprintf(stderr, "Error: spawn error (code: %d)\n", errno);
		return(2);
	}

	close(qnx_spawn_options.iov[1]);
	qnx_spawn_options.iov[1] = -1;

	printf("Mounting RAM disk as /\n");
	fflush(stdout);
	if (mount("/dev/ram", "/", 0))
	{
		fprintf(stderr, "Error: can't mount /dev/ram (code: %d)\n", errno);
		return(2);
	}

	printf("Spawning initializator (%s)...\n", sinit);
	fflush(stdout);

//	if ((pid = qnx_spawn(1, NULL, 0, -1, -1, SPWN_F, "/bin/sinit", argv[0], arge, NULL, -1)) == -1)
	if ((pid = spawnl(P_OVERLAY, sinit, basename(sinit), "TERM=qnx", NULL)) == -1)
	{
		printf("Error: spawn error (code: %d)!\n", errno);
		return(1);
	}

	return(0);
}	
